<?php

function event_pagec($page) {
	$event = $GLOBALS['PAGE']['event'];
	$pagec = file_get_contents($GLOBALS['PAGE_DIR'] . $page); 
	$objects = array();
	$objects['*'] = $GLOBALS['PAGE']['label'];
	$output = _event_pagec_parseloops($event, $pagec, $objects);
	print $output;
}

function _event_pagec_parseloops($event, $page, $objects=array())
{
	$len = strlen($page);
	$i=0; $j=-1; $last_output=0;
	$output = "";
	$tokLen=strlen('@*');
	while($i < $len)
	{
		$i=strpos($page, ($j<0?'@*':'*@'), $i);
		if($i !== false)
		{
			if($j < 0)
			{
				$j=$i++;
			} 
			else
			{
				if($j != $last_output)
				{
					$data = substr($page, $last_output, $j-$last_output);
					$output .= _event_pagec($event, $data, $objects);
				}
				$string = substr($page, $j+$tokLen, $i-$j-$tokLen); $j=-1;
				$values = split("#", $string, 3);
				if(sizeof($values)==3)
				{
					$myValues = $event->getEValue($values[1]);
					if(!is_array($myValues))
					{
						if($myValues)
						{
							$myValues = array($myValues);
						}
					}
					if(is_array($myValues))
					{
						foreach($myValues as $v)
						{
							$objects[$values[0]] = $v;
							$value  = _event_pagec($event, $values[2], $objects);
							$output .= $value;
						}
					}
				}
				$i+=$tokLen;
				$last_output = $i;
			}
		}
		else
		{
			if($last_output < $len) 
			{
				$data = substr($page, $last_output, $len-$last_output);
				$output .= _event_pagec($event, $data);
			}
			$i=$len;
		}
	}
	return $output;
}

function _event_pagec_getValue($objects, $key)
{
	$value = null;
	if($value = $objects[$key])
	{
		return $value;
	}
	list($newKey, $restKey) = split("\.", $key, 2);
	if($value = $objects[$newKey])
	{
		return _event_pagec_getValue($value, $restKey);
	}
	return null;
}

#
# Renders a page without loops
#
function _event_pagec($event, $page, $objects=array())
{
	$len = strlen($page);
	$i=0; $j=-1; $last_output=0;
	$output = "";
	while($i < $len)
	{
		$i=strpos($page, '@', $i);
		if($i !== false)
		{
			if($j < 0)
			{
				$j=$i++;
			} 
			else
			{
				if($j != $last_output)
				{
					$output .= substr($page, $last_output, $j-$last_output);
				}
				$string = substr($page, $j+1, $i-$j-1); $j=-1;
				$values = split("#", $string);
				$key = array_shift($values);
				$value = $key?event_text($key):"{0}";
				for($x=0; $x < sizeof($values); ++$x)
				{
					if($values[$x]=="") next;
					if(!($myValue  = _event_pagec_getValue($objects, $values[$x])))
					{
						$myValue = $event->getEValue($values[$x]);
					}
					$value = str_replace('{' . $x . '}', $myValue, $value);
				}
				$output .= $value;
				$last_output = ++$i;
			}
		}
		else
		{
			if($last_output < $len) $output .= substr($page, $last_output, $len-$last_output);
			$i=$len;
		}
	}
	return $output;
}

?>
